local name = 'kEnergy'
local dewdrop = AceLibrary('Dewdrop-2.0')

function kEnergy:CreateFrame()
    self.frame = CreateFrame('Frame', name..'Frame', UIParent)
    self.frame:SetMovable(true)
    self.frame:RegisterForDrag('LeftButton')
    self.frame:SetWidth(self.db.profile.width)
    self.frame:SetHeight(self.db.profile.height)

    self.frame:SetScript('OnDragStart', function(this, button)
        this:StartMoving()
    end)

    self.frame:SetScript('OnDragStop', function(this, button)
        this:StopMovingOrSizing()
        self:SavePosition()
    end)

    self.frame:SetScript('OnMouseUp', function(this, button)
        if button == 'RightButton' then
            dewdrop:Open(self.frame)
        end
    end)

    self.frame.text = self.frame:CreateFontString(nil, "OVERLAY")
    self.frame.text:SetPoint("CENTER", self.frame, "CENTER", 0, 1)
    self:SetFontSize()

    self.frame:SetFrameStrata("HIGH")

    dewdrop:Register(self.frame,
                     'children', function()
                         dewdrop:FeedAceOptionsTable(self.options)
                     end,
                     'point', function() return 'BOTTOMLEFT', 'TOPLEFT' end)

    self:SetCandyBarPoint(name, 'TOPLEFT', self.frame, 'TOPLEFT', 0, 0)
    self:SetCandyBarPoint(name, 'TOPRIGHT', self.frame, 'TOPRIGHT', 0, 0)
    self:SetCandyBarPoint(name, 'BOTTOMLEFT', self.frame, 'BOTTOMLEFT', 0, 0)
    self:SetCandyBarPoint(name, 'BOTTOMRIGHT', self.frame, 'BOTTOMRIGHT', 0, 0)
end

function kEnergy:SetFontSize()
    local font, _, style = NumberFontNormal:GetFont()
    self.frame.text:SetFont(font, self.db.profile.fontsize, style)
end

function kEnergy:RestorePosition()
    if(self.db.profile.pos) then
        local x, y = string.split(' ', self.db.profile.pos)
        local s = self.frame:GetEffectiveScale()

        self.frame:ClearAllPoints()
        self.frame:SetPoint('TOPLEFT', UIParent, 'BOTTOMLEFT', x/s, y/s)
    else
        self.frame:ClearAllPoints()
        self.frame:SetPoint('CENTER', UIParent, 'CENTER', 0, 0)
    end
end

function kEnergy:SavePosition()
    local f = self.frame
    local x,y = f:GetLeft(), f:GetTop()
    local s = f:GetEffectiveScale()

    x, y = x*s, y*s

    self.db.profile.pos = string.format('%s %s', x, y)
end
